//
// Implementazione della Classe Stack, prima versione.
//


#include <iostream.h>
#include "Stack1.H"


// Costruttore per il tipo di dato Pila.
Stack::Stack(int len)
{
  if (len < 1) {
    cerr << "Errore: la Pila deve avere almeno un elemento!" << endl;
    exit(-1);
  }

  data = new mytype[len];	// Crea un array di lunghezza assegnata
  head = 0;
  maxlen = len;
}


// Distruttore per il tipo di dato Pila.
Stack::~Stack()
{
  delete[] data;
}


// Restituisce l'elemento in testa alla Pila
mytype Stack::Read()
{
  if (IsEmpty()) {
    cerr << "Errore: la Pila e` vuota!" << endl;
    exit(-2);
  }

  return(data[head - 1]);
}


// Rimuove un elemento dalla testa della Pila
mytype Stack::Pop()
{
  if (IsEmpty()) {
    cerr << "Errore: la Pila e` vuota!" << endl;
    exit(-2);
  }

  return(data[--head]);
}


// Inserisce l'elemento d in testa alla Pila
void Stack::Push(const mytype &d)
{
  if (head != maxlen)
    data[head++] = d;
  else {
    cerr << "Errore: la Pila e` piena!" << endl;
    exit(-2);
  }
}



